typedef unsigned int    uint;
typedef long double     longdouble;

class DW
{
public:
    enum FunctionType
    {
        ScalingFunction,
        WaveletFunction
    };
	enum ScaleFunction
	{
		Hat,
		Haar=2,
		D4=4,D6=6,D8=8,D12=12,D20=20
	};
	static double           c12[12];
	static double           c20[20];
protected:
	int             initialized;
    double          C[20];
	ScaleFunction 	type;
public:
	DW(const uint);
    ScaleFunction   Type()  {   return type;    }

	void     InitCoeffs(const ScaleFunction);
	double   DSF(double,uint);
	double   DSW(double,uint);

	static double   HaarFunction(const double x)    {	return x>=0.0 && x<1.0;	}
    static int          SupportInf(FunctionType,uint);
    static int          SupportSup(FunctionType,uint);
};

