//---------------------------------------------------------------------------
#ifndef DCTvsDWTH
#define DCTvsDWTH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\FileCtrl.hpp>
//---------------------------------------------------------------------------
struct 	TransformGroup;
class   TransformThread;
class TMainWindow : public TForm
{
__published:	// IDE-managed Components
	TPageControl *TransformPageControl;
	TTabSheet *FourierTabSheet;
	TTabSheet *DaubTabSheet;
	TTabSheet *HaarTabSheet;
	TSpeedButton *OpenButton;
	TSpeedButton *SaveButton;
	TSpeedButton *ConvertButton;
	TSpeedButton *ExitButton;
	TSpeedButton *AboutButton;
	TTrackBar *FourierErrorTrackBar;
	TLabel *FourierErrorLabel;
	TLabel *FourierWinSizeLabel;
	TProgressBar *FourierCompressBar;
	TLabel *FourierCompressLabel;
	TTrackBar *FourierWinSizeTrackBar;
	TPageControl *OriginalPageControl;
	TTabSheet *OriginalTabSheet;
	TTabSheet *OpenOriginalImage;
	TOpenDialog *OpenImageDialog;
	TSaveDialog *SaveImageDialog;
	TTrackBar *DaubErrorTrackBar;
	TTrackBar *DaubWinSizeTrackBar;
	TLabel *DaubWinSizeLabel;
	TLabel *DaubErrorLabel;
	TLabel *DaubCompressLabel;
	TProgressBar *DaubCompressBar;
	TTrackBar *HaarErrorTrackBar;
	TTrackBar *HaarWinSizeTrackBar;
	TLabel *HaarWinSizeLabel;
	TLabel *HaarErrorLabel;
	TLabel *HaarCompressLabel;
	TProgressBar *HaarCompressBar;
	TDriveComboBox *QuickViewDriveComboBox;
	TFileListBox *QuickViewFileListBox;
	TDirectoryListBox *QuickViewDirectoryListBox;
	TImage *QuickViewImage;
	TFilterComboBox *QuickViewFilterComboBox;
	TEdit *QuickViewEdit;
	TProgressBar *TransformProgressBar;
	TLabel *TransformProgressLabel;
	TBevel *QuickViewBevel;
	TCheckBox *HaarGridBox;
	TCheckBox *DaubGridBox;
	TCheckBox *FourierGridBox;
	TScrollBox *ScrollBox2;
	TImage *OriginalImage;
	TScrollBox *ScrollBox3;
	TImage *FourierImage;
	TScrollBox *ScrollBox4;
	TImage *DaubImage;
	TScrollBox *ScrollBox5;
	TImage *HaarImage;
	TCheckBox *FourierColorCorrection;
	TTabSheet *Fourier2DTabSheet;
	TTabSheet *Daub2DTabSheet;
	TTabSheet *Haar2DTabSheet;
	TCheckBox *DaubColorCorrection;
	TCheckBox *HaarColorCorrection;
	TLabel *Fourier2DWinSizeLabel;
	TTrackBar *Fourier2DWinSizeTrackBar;
	TCheckBox *Fourier2DGridBox;
	TCheckBox *Fourier2DColorCorrection;
	TLabel *Fourier2DErrorLabel;
	TLabel *Fourier2DCompressLabel;
	TTrackBar *Fourier2DErrorTrackBar;
	TProgressBar *Fourier2DCompressBar;
	TLabel *Daub2DWinSizeLabel;
	TTrackBar *Daub2DWinSizeTrackBar;
	TCheckBox *Daub2DGridBox;
	TCheckBox *Daub2DColorCorrection;
	TLabel *Daub2DErrorLabel;
	TLabel *Daub2DCompressLabel;
	TTrackBar *Daub2DErrorTrackBar;
	TProgressBar *Daub2DCompressBar;
	TLabel *Haar2DWinSizeLabel;
	TTrackBar *Haar2DWinSizeTrackBar;
	TCheckBox *Haar2DGridBox;
	TCheckBox *Haar2DColorCorrection;
	TLabel *Haar2DErrorLabel;
	TLabel *Haar2DCompressLabel;
	TTrackBar *Haar2DErrorTrackBar;
	TProgressBar *Haar2DCompressBar;
	TScrollBox *ScrollBox6;
	TImage *Fourier2DImage;
	TScrollBox *ScrollBox7;
	TImage *Daub2DImage;
	TScrollBox *ScrollBox8;
	TImage *Haar2DImage;
	TLabel *QuickViewLabel;
	void __fastcall SelectImageToView(TObject *Sender);
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall OpenButtonClick(TObject *Sender);
	void __fastcall SaveButtonClick(TObject *Sender);
	void __fastcall SelectImageToConvert(TObject *Sender);
	void __fastcall ConvertButtonClick(TObject *Sender);
	void __fastcall AboutButtonClick(TObject *Sender);
	void __fastcall ChangeErrorLabel(TObject *Sender);
	void __fastcall ZoomInImage(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall ChangeActivePage(TObject *Sender);
	void __fastcall DrawGrid(TObject *Sender);
	
	void __fastcall ZoomOriginalImage(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall ShowGrid(TObject *Sender);
	void __fastcall CloseHdl(TObject *Sender, TCloseAction &Action);
	




private:	// User declarations
	TransformGroup 	*trGroup;
    TransformGroup	*activeGroup;
    AnsiString 		imagePath;
public:		// User declarations
	__fastcall TMainWindow(TComponent* Owner);
	void __fastcall ConversionFinished(TObject *);

	void __fastcall convert();

};
//---------------------------------------------------------------------------
struct TransformGroup
{
		TTabSheet 				*tabSheet;
        TImage                  *image;
        TCheckBox               *showGrid;
        TCheckBox               *correction;
        TTrackBar               *errorBar;
        TLabel                  *errorLabel;
        TTrackBar               *gridBar;
        TLabel                  *gridLabel;
        TProgressBar    		*compressBar;
        TLabel                  *compressLabel;
    	Transform           	*transform;
        Transformer::Zig		zig;
        int						previousGridBar;
        bool					dirtyOriginal;
        bool					dirty;
        bool					busy;

        TransformThread			*thread;
};

extern TMainWindow *MainWindow;
//---------------------------------------------------------------------------
#endif
